unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, Gauges, Menus,
  VBScript_RegExp_55_TLB;

//-----------------------------------------------------------------------------
type
    TPageInfo = record
        URL: string;
        Status: string;
        HttpCode: integer;
        ContentType: string;
        Charset: string;
        Title: string;
        Description: string;
    end;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuExit: TMenuItem;
    MenuMisc: TMenuItem;
    MenuInfo: TMenuItem;
    MenuStayOnTop: TMenuItem;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    Splitter1: TSplitter;
    Memo2: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure MenuInfoClick(Sender: TObject);
    procedure MenuExitClick(Sender: TObject);
    procedure MenuStayOnTopClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    FRegBuf: TRegExp;
    FStrBuf: TStringList;
    function GetPageInformation(const URL: string): TPageInfo;
  public

  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
    StrUtils, Jconvert, Info, Http;

//-----------------------------------------------------------------------------
//  2005.09.03  RXgN^
procedure TMainForm.FormCreate(Sender: TObject);
begin
    SetFormCaption(Self);
    FRegBuf := TRegExp.Create(nil);
    FStrBuf := TStringList.Create();
end;

//-----------------------------------------------------------------------------
//  2005.09.03  fXgN^
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    FRegBuf.Free;
    FStrBuf.Free;
end;

//-----------------------------------------------------------------------------
//  2005.09.04  Pagȅ擾
function TMainForm.GetPageInformation(const URL: string): TPageInfo;

    //  Tu}b`1ڂ߂
    function GetSubMatchItem0(const Data, Pattern: string): string;
    var
        Matches, SubMatches: OleVariant;
    begin
        Result := '';
        FRegBuf.Pattern := Pattern;
        FRegBuf.Global := false;            //  ŏ
        FRegBuf.IgnoreCase := true;         //  啶E
        Matches := FRegBuf.Execute(Data);   //  
        if (Matches.Count > 0) then
        begin
            SubMatches := Matches.Item[0].SubMatches;
            if (SubMatches.Count > 0) then
            begin
                Result := SubMatches.Item[0];
            end;
        end;
    end;

var
    ss: TStringStream;
    Data, Pattern: string;
begin
    //  
    FillChar(Result, SizeOf(Result), #0);

    //  URLZbg
    Result.URL := URL;

    ss := nil;
    try
        //  f[^󂯎Xg[쐬
        ss := TStringStream.Create('');

        //  _E[h
        if (GetHttpData(URL, ss)) then
        begin
            //  wb_̃Xg[f[^𕶎
            Data := ss.DataString;

            //  pς
            FreeAndNil(ss);

            //  Xe[^Xo
            Pattern := '(^HTTP/[0-9]\.[0-9][\s]+[0-9]+[\s]+[^\n]*)';
            Result.Status := GetSubMatchItem0(Data, Pattern);

            //  Xe[^XR[ho
            Pattern := '^HTTP/[0-9]\.[0-9][\s]+([0-9]+)[\s]+[^\n]*';
            Result.HttpCode := StrToIntDef(GetSubMatchItem0(Result.Status, Pattern), -1);

            //  Content-Typeo
            Pattern := 'Content-Type:[\s]*([^;|\n]*)';
            Result.ContentType := Trim(GetSubMatchItem0(Data, Pattern));

            //  Content-TypeN̂
            if (Result.ContentType = '') then
            begin
                Pattern := 'http-equiv=["]?content-type"[\s]+content=["]?([^;"]*)';
                Result.ContentType := Trim(GetSubMatchItem0(Data, Pattern));
            end;

            //  charseto(T[o[X|XMETA^Oɔ)
            Pattern := ';[\s]*charset[\s]*=[\s]*([^\n">]*)';
            Result.Charset := Trim(GetSubMatchItem0(Data, Pattern));

            if (Result.HttpCode = 302) then
            begin
                //  Location o
                Pattern := 'Location:[\s]*([^\n]*)';
                ShowMessage(GetSubMatchItem0(Data, Pattern));
            end;

            //  EUC̏ꍇ
            if (AnsiContainsText(Result.Charset, 'euc')) then
            begin
                Data := euc2sjis(Data);
            end
            //  ̑̏ꍇ
            else
            begin
                Data := ConvertJCode(Data, SJIS_OUT);
            end;

            //  s𗎂Ƃ
            Data := StringReplace(Data, #13, '', [rfReplaceAll]);
            Data := StringReplace(Data, #10, '', [rfReplaceAll]);

            //  ^Cg^O̔
            Pattern := '<TITLE>([^<]*)</TITLE>';
            Result.Title := GetSubMatchItem0(Data, Pattern);

            //  ̔
            Pattern := '<META[\s]*NAME[\s]*=[\s]*"?[\s]*description[\s]*"?[\s]*CONTENT[\s]*=[\s]*"?[^>"]*"?[\s]*>';
            Result.Description := GetSubMatchItem0(Data, Pattern);
        end;
    finally
        //  Xg[j
        FreeAndNil(ss);
    end;
end;

//  ---------------------------------------------------------------------------
//  s
procedure TMainForm.MenuInfoClick(Sender: TObject);
begin
    OpenInfoForm();
end;

procedure TMainForm.MenuExitClick(Sender: TObject);
begin
    Self.Close();
end;

procedure TMainForm.MenuStayOnTopClick(Sender: TObject);
begin
    if (MenuStayOnTop.Checked) then
        Self.FormStyle := fsStayOnTop
    else
        Self.FormStyle := fsNormal;
end;

procedure TMainForm.BitBtn1Click(Sender: TObject);
var
    i: integer;
    PageInfo: TPageInfo;
begin
    for i := 0 to Memo1.Lines.Count - 1 do
    begin
        PageInfo := GetPageInformation(Memo1.Lines.Strings[i]);
        Memo2.Lines.Add(StringOfChar('-', 50));
        Memo2.Lines.Add(Memo1.Lines.Strings[i]);
        Memo2.Lines.Add(PageInfo.Status);
        Memo2.Lines.Add(PageInfo.ContentType);
        Memo2.Lines.Add(PageInfo.Charset);
        Memo2.Lines.Add(PageInfo.Title);
        Memo2.Lines.Add(PageInfo.Description);
    end;
end;

end.

